Subject: Re: [PATCH net] net: cdc_ncm: workaround for missing CDC Union

From: Bjørn Mork <[email-masked]>
Date: Fri, 18 Jan 2013 22:17:03 +0100

Oliver Neukum <[email-masked]> writes:
> On Friday 18 January 2013 15:25:47 Bjørn Mork wrote:
>> Adding support for the MBIM mode in some Sierra Wireless devices.
>> 
>> Some Sierra Wireless firmwares support CDC MBIM but have no CDC
>> Union funtional descriptor. This violates the MBIM specification,
>> but we can easily work around the bug by looking at the Interface
>> Association Descriptor instead.  This is most likely what
>> Windows uses too, which explains how the firmware bug has gone
>> unnoticed until now.
>
> Should we do this for everything CDC?

I don't know.  There are workarounds for missing CDC Union descriptors
on RNDIS devices in cdc_ether.c, but I have no idea if those devices in
provide an IAD instead.  I don't think this bug is a very common.

MBIM devices are likely to have IADs because Microsoft let you skip some
of the more hairy vendor specific control message parts if you provide
one:
http://msdn.microsoft.com/en-us/library/windows/hardware/mbim-based-mobile-broadband-requirements-for-windows.aspx

But they should of course provide the CDC Union functional descriptor as
well, even if that is "just" a USB-IF requirement and not a Windows
requirement ;-)

Bjørn
--
To unsubscribe from this list: send the line "unsubscribe linux-usb" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html